package ch.hevs.isi.field;

import ch.hevs.isi.core.DataPoint;

import java.util.HashMap;
import java.util.Map;

public abstract class ModbusRegister {
    protected int address;
    public static HashMap<DataPoint, ModbusRegister> map = new HashMap<>();
    public void updateMapOfRegisters(DataPoint dp, int address){
        this.address = address;
        map.put(dp,this);
    }
    public static ModbusRegister getRegisterFromDatapoint(DataPoint dp){
        return map.get(dp);
    }
    public int getAddress() {
        return address;
    }

    public static void poll(){
        for (ModbusRegister mr : map.values()){
            mr.read();                              //read all values (registers) of the map
        }
    }
    public abstract void read();        //abstract prototype of the method read
    public abstract void write();       //abstract prototype of the method read
}
